import React, { ReactNode } from 'react';
import { PopupProps } from '../popup';
import { ElementProps } from '../../utils/element-props';
export declare type PickerValue = string | null;
export declare type PickerColumnItem = {
    label: string;
    value: string;
};
export declare type PickerColumn = (string | PickerColumnItem)[];
export declare type PickerProps = {
    columns: PickerColumn[] | ((value: PickerValue[]) => PickerColumn[]);
    value?: PickerValue[];
    defaultValue?: PickerValue[];
    onSelect?: (value: PickerValue[]) => void;
    onConfirm?: (value: PickerValue[]) => void;
    onCancel?: () => void;
    onClose?: () => void;
    visible?: boolean;
    confirmText?: string;
    cancelText?: string;
    children?: (items: (PickerColumnItem | null)[]) => ReactNode;
} & Pick<PopupProps, 'getContainer'> & ElementProps;
declare const _default: React.FC<PickerProps> & {
    Cascader: React.FC<import("./cascader").CascaderProps>;
};
export default _default;
