import React from 'react';
import { Circle as RCProgressCircle } from 'rc-progress';
import classNames from 'classnames';
import { withDefaultProps } from '../../utils/with-default-props';
import { convertPx } from '../../utils/convert-px';
var classPrefix = "am-progress";
var ProgressCircle = withDefaultProps({
  percent: 0,
  strokeWidth: convertPx(6),
  size: convertPx(50),
  strokeColor: '#1677FF'
})(function (props) {
  var contentStyle = {
    width: props.size + "px",
    height: props.size + "px"
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix + "-circle-wrap", props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-circle-content",
    style: contentStyle
  }, /*#__PURE__*/React.createElement(RCProgressCircle, {
    prefixCls: classPrefix,
    percent: props.percent,
    strokeWidth: props.strokeWidth,
    trailWidth: props.strokeWidth,
    trailColor: "#E5E5E5",
    strokeColor: props.strokeColor
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-circle-info"
  }, props.children)));
});
export default ProgressCircle;