import React from 'react';
import classNames from 'classnames';
var classPrefix = "am-step";

var Step = function Step(props) {
  var title = props.title,
      description = props.description,
      icon = props.icon,
      _props$status = props.status,
      status = _props$status === void 0 ? 'wait' : _props$status;
  var iconClass = classNames(classPrefix + "-icon-dot", classPrefix + "-icon-dot-" + status);
  var descriptionClass = classNames(classPrefix + "-item-description", classPrefix + "-item-description-" + status);
  var contentClass = classNames(classPrefix + "-item-content", classPrefix + "-item-content-" + status);
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-icon"
  }, /*#__PURE__*/React.createElement("span", {
    className: iconClass
  }, icon)), /*#__PURE__*/React.createElement("div", {
    className: contentClass
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-title"
  }, title), /*#__PURE__*/React.createElement("div", {
    className: descriptionClass
  }, description)));
};

export default Step;