"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var loading_1 = __importDefault(require("../loading"));

var classPrefix = "am-button";

var Button = function Button(props) {
  var _classnames_1$default;

  var disabled = props.disabled || props.loading;
  return /*#__PURE__*/React.createElement("button", {
    type: props.type,
    onClick: props.onClick,
    className: classnames_1["default"](classPrefix, props.color ? classPrefix + "-" + props.color : null, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-block"] = props.block, _classnames_1$default[classPrefix + "-disabled"] = disabled, _classnames_1$default[classPrefix + "-fill-outline"] = props.fill === 'outline', _classnames_1$default[classPrefix + "-fill-none"] = props.fill === 'none', _classnames_1$default[classPrefix + "-mini"] = props.size === 'mini', _classnames_1$default[classPrefix + "-small"] = props.size === 'small', _classnames_1$default[classPrefix + "-large"] = props.size === 'large', _classnames_1$default[classPrefix + "-loading"] = props.loading, _classnames_1$default), props.className),
    style: props.style,
    disabled: disabled
  }, props.loading ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-loading-wrapper"
  }, /*#__PURE__*/React.createElement(loading_1["default"], {
    color: "currentColor",
    size: props.size
  }), props.loadingText)) : props.children);
};

Button.defaultProps = {
  color: 'default',
  fill: 'solid',
  block: false,
  loading: false,
  type: 'button'
};
exports["default"] = Button;