"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var with_default_props_1 = require("../../utils/with-default-props");

var react_1 = require("react");

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-image";
var defaultProps = {
  fit: 'fill',
  placeholder: /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-tip"
  }, /*#__PURE__*/React.createElement(icons_1.PictureOutlined, null)),
  fallback: /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-tip"
  }, /*#__PURE__*/React.createElement(icons_1.DisconnectOutlined, null))
};
var Image = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _react_1$useState = react_1.useState(false),
      loaded = _react_1$useState[0],
      setLoaded = _react_1$useState[1];

  var _react_1$useState2 = react_1.useState(false),
      failed = _react_1$useState2[0],
      setFailed = _react_1$useState2[1];

  function renderInner() {
    if (failed) {
      return props.fallback;
    }

    return /*#__PURE__*/React.createElement(React.Fragment, null, !loaded && props.placeholder, /*#__PURE__*/React.createElement("img", {
      className: classPrefix + "-img",
      src: props.src,
      onLoad: function onLoad() {
        setLoaded(true);
      },
      onError: function onError(e) {
        setFailed(true);
        props.onError == null ? void 0 : props.onError(e);
      },
      style: {
        objectFit: props.fit,
        display: loaded ? 'block' : 'none'
      },
      crossOrigin: props.crossOrigin,
      decoding: props.decoding,
      loading: props.loading,
      referrerPolicy: props.referrerPolicy,
      sizes: props.sizes,
      srcSet: props.srcSet,
      useMap: props.useMap
    }));
  }

  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: _extends({
      width: props.width,
      height: props.height
    }, props.style)
  }, renderInner());
});
exports["default"] = Image;