"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Sidebar = void 0;

var react_1 = require("react");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-index-bar";

exports.Sidebar = function (props) {
  var _classnames_1$default;

  var _react_1$useState = react_1.useState(false),
      interacting = _react_1$useState[0],
      setInteracting = _react_1$useState[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix + "-sidebar", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-sidebar-interacting"] = interacting, _classnames_1$default)),
    onMouseDown: function onMouseDown() {
      setInteracting(true);
    },
    onMouseUp: function onMouseUp() {
      setInteracting(false);
    },
    onTouchStart: function onTouchStart() {
      setInteracting(true);
    },
    onTouchEnd: function onTouchEnd() {
      setInteracting(false);
    },
    onTouchMove: function onTouchMove(e) {
      if (!interacting) return;
      var _e$touches$ = e.touches[0],
          clientX = _e$touches$.clientX,
          clientY = _e$touches$.clientY;
      var target = document.elementFromPoint(clientX, clientY);
      if (!target) return;
      var index = target.dataset['index'];

      if (index) {
        props.onActive(index);
      }
    }
  }, props.indexes.map(function (index) {
    var _classnames_1$default2;

    var active = index === props.activeIndex;
    return /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-sidebar-row",
      onMouseDown: function onMouseDown() {
        props.onActive(index);
      },
      onTouchStart: function onTouchStart() {
        props.onActive(index);
      },
      onMouseEnter: function onMouseEnter() {
        if (interacting) {
          props.onActive(index);
        }
      },
      "data-index": index,
      key: index
    }, interacting && active && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-sidebar-bubble"
    }, index), /*#__PURE__*/React.createElement("div", {
      className: classnames_1["default"](classPrefix + "-sidebar-item", (_classnames_1$default2 = {}, _classnames_1$default2[classPrefix + "-sidebar-item-active"] = active, _classnames_1$default2)),
      "data-index": index
    }, /*#__PURE__*/React.createElement("div", null, index)));
  }));
};