"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-list";

var ListItem = function ListItem(props) {
  var _props$showArrow;

  var showArrow = (_props$showArrow = props.showArrow) != null ? _props$showArrow : !!props.onClick;
  var content = /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content"
  }, props.prefix && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-prefix"
  }, props.prefix), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-main"
  }, props.title && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-title"
  }, props.title), /*#__PURE__*/React.createElement("div", null, props.children), props.description && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-description"
  }, props.description)), props.extra && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-extra"
  }, props.extra), showArrow && /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-content-arrow"
  }, /*#__PURE__*/React.createElement(icons_1.RightOutlined, null)));
  return props.onClick ? /*#__PURE__*/React.createElement("a", {
    className: classnames_1["default"](classPrefix + "-item", "am-plain-anchor", props.className),
    style: props.style,
    onClick: props.onClick
  }, content) : /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix + "-item", props.className),
    style: props.style
  }, content);
};

var List = function List(props) {
  var className = classnames_1["default"](classPrefix, classPrefix + "-" + props.mode, props.className);
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-inner"
  }, props.children));
};

List.defaultProps = {
  mode: 'default'
};
List.Item = ListItem;
exports["default"] = List;