"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var classnames_1 = __importDefault(require("classnames"));

var react_1 = __importDefault(require("react"));

var convert_px_1 = require("../../utils/convert-px");

var with_default_props_1 = require("../../utils/with-default-props");

var classPrefix = "am-progress-bar";
var ProgressBar = with_default_props_1.withDefaultProps({
  percent: 0,
  strokeWidth: convert_px_1.convertPx(3),
  strokeColor: '#1677FF'
})(function (props) {
  var strokeWidth = props.strokeWidth;
  var trailStyle = {
    height: strokeWidth + "px",
    borderRadius: strokeWidth / 2 + "px",
    background: '#e5e5e5'
  };
  var pathStyle = {
    height: strokeWidth + "px",
    borderRadius: strokeWidth / 2 + "px",
    width: props.percent + "%",
    background: props.strokeColor,
    transition: 'width 0.3s'
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-trail",
    style: trailStyle
  }, /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix + "-path"),
    style: pathStyle
  })));
});
exports["default"] = ProgressBar;