"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var rc_progress_1 = require("rc-progress");

var classnames_1 = __importDefault(require("classnames"));

var with_default_props_1 = require("../../utils/with-default-props");

var convert_px_1 = require("../../utils/convert-px");

var classPrefix = "am-progress";
var ProgressCircle = with_default_props_1.withDefaultProps({
  percent: 0,
  strokeWidth: convert_px_1.convertPx(6),
  size: convert_px_1.convertPx(50),
  strokeColor: '#1677FF'
})(function (props) {
  var contentStyle = {
    width: props.size + "px",
    height: props.size + "px"
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix + "-circle-wrap", props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-circle-content",
    style: contentStyle
  }, /*#__PURE__*/React.createElement(rc_progress_1.Circle, {
    prefixCls: classPrefix,
    percent: props.percent,
    strokeWidth: props.strokeWidth,
    trailWidth: props.strokeWidth,
    trailColor: "#E5E5E5",
    strokeColor: props.strokeColor
  }), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-circle-info"
  }, props.children)));
});
exports["default"] = ProgressCircle;