"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var classPrefix = "am-result";
var ICONS = {
  success: icons_1.CheckCircleFilled,
  error: icons_1.CloseCircleFilled,
  info: icons_1.InfoCircleFilled,
  waiting: icons_1.ClockCircleFilled,
  warning: icons_1.ExclamationCircleFilled
};

var Result = function Result(props) {
  var className = props.className,
      style = props.style,
      status = props.status,
      title = props.title,
      description = props.description;
  var ResultIcon = ICONS[status];
  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix, classPrefix + "-" + status, className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-icon"
  }, /*#__PURE__*/React.createElement(ResultIcon, null)), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-title"
  }, title), description ? /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-description"
  }, description) : null);
};

Result.defaultProps = {
  description: ''
};
exports["default"] = Result;