"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = require("react");

var react_use_gesture_1 = require("react-use-gesture");

var classPrefix = "am-slider";

var Thumb = function Thumb(props) {
  var value = props.value,
      min = props.min,
      max = props.max,
      disabled = props.disabled,
      onDrag = props.onDrag;
  var prevValue = react_1.useRef(value);

  var currentPosition = function currentPosition() {
    return {
      left: (value - min) / (max - min) * 100 + "%",
      right: 'auto'
    };
  };

  var bind = react_use_gesture_1.useDrag(function (state) {
    var _props$trackRef$curre;

    if (disabled) return;

    if (state.first) {
      prevValue.current = value;
    }

    var _react_use_gesture_1$ = react_use_gesture_1.subV(state.xy, state.initial),
        x = _react_use_gesture_1$[0];

    var sliderOffsetWith = (_props$trackRef$curre = props.trackRef.current) == null ? void 0 : _props$trackRef$curre.offsetWidth;
    if (!sliderOffsetWith) return;
    var diff = x / Math.ceil(sliderOffsetWith) * (max - min);
    onDrag(prevValue.current + diff, state.first, state.last);
  }, {
    axis: 'x'
  });
  return /*#__PURE__*/React.createElement("div", _extends({
    className: classPrefix + "-thumb-container",
    style: currentPosition()
  }, bind()), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-thumb"
  }));
};

exports["default"] = Thumb;