"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-step";

var Step = function Step(props) {
  var title = props.title,
      description = props.description,
      icon = props.icon,
      _props$status = props.status,
      status = _props$status === void 0 ? 'wait' : _props$status;
  var iconClass = classnames_1["default"](classPrefix + "-icon-dot", classPrefix + "-icon-dot-" + status);
  var descriptionClass = classnames_1["default"](classPrefix + "-item-description", classPrefix + "-item-description-" + status);
  var contentClass = classnames_1["default"](classPrefix + "-item-content", classPrefix + "-item-content-" + status);
  return /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-container"
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-icon"
  }, /*#__PURE__*/React.createElement("span", {
    className: iconClass
  }, icon)), /*#__PURE__*/React.createElement("div", {
    className: contentClass
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-item-title"
  }, title), /*#__PURE__*/React.createElement("div", {
    className: descriptionClass
  }, description)));
};

exports["default"] = Step;