"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var classnames_1 = __importDefault(require("classnames"));

var icons_1 = require("@ant-design/icons");

var step_1 = __importDefault(require("./step"));

var with_default_props_1 = require("../../utils/with-default-props");

var attach_properties_to_component_1 = require("../../utils/attach-properties-to-component");

var classPrefix = "am-steps";
var stepClassPrefix = "am-step";
var defaultIconMap = {
  error: /*#__PURE__*/React.createElement(icons_1.CloseCircleFilled, null),
  finish: /*#__PURE__*/React.createElement(icons_1.CheckCircleFilled, null),
  process: /*#__PURE__*/React.createElement("span", {
    className: stepClassPrefix + "-item-icon-process"
  }),
  wait: /*#__PURE__*/React.createElement("span", {
    className: stepClassPrefix + "-item-icon-wait"
  })
};
var defaultProps = {
  current: 0,
  direction: 'horizontal'
};
var Steps = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var direction = props.direction,
      current = props.current;
  var classString = classnames_1["default"](classPrefix + "-" + direction);
  return /*#__PURE__*/React.createElement("div", {
    className: classString
  }, react_1["default"].Children.map(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) {
      return child;
    }

    var props = child.props;
    var status = props.status || 'wait';
    var icon = props.icon; // 小于当前步骤的默认状态是进行中，大于当前步骤的是表示未完成。

    if (index < current) {
      status = props.status || 'finish';
    } else if (index === current) {
      status = props.status || 'process';
    }

    if (direction === 'vertical') {
      icon = icon || defaultIconMap[status];
    }

    return react_1["default"].cloneElement(child, {
      status: status,
      icon: icon
    });
  }));
});
exports["default"] = attach_properties_to_component_1.attachPropertiesToComponent(Steps, {
  Step: step_1["default"]
});