"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-tab-bar";

var TabBarItem = function TabBarItem() {
  return null;
};

var TabBar = function TabBar(props) {
  var firstActiveKey = undefined;
  var items = [];
  react_1["default"].Children.forEach(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    items.push(child);
  });

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _ahooks_1$useControll[0],
      setActiveKey = _ahooks_1$useControll[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, items.map(function (item) {
    var _classnames_1$default;

    return /*#__PURE__*/React.createElement("div", {
      key: item.key,
      onClick: function onClick() {
        var _item$key;

        setActiveKey((_item$key = item.key) == null ? void 0 : _item$key.toString());
      },
      className: classnames_1["default"](classPrefix + "-item", item.props.className, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-item-active"] = item.key === activeKey, _classnames_1$default))
    }, item.props.icon && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item-icon"
    }, item.props.icon), item.props.title && /*#__PURE__*/React.createElement("div", {
      className: classPrefix + "-item-title"
    }, item.props.title), item.props.children);
  }));
};

TabBar.Item = TabBarItem;
exports["default"] = TabBar;