"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var ahooks_1 = require("ahooks");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-tabs";

var TabPane = function TabPane() {
  return null;
};

var Tabs = function Tabs(props) {
  var childrenRecord = {};
  var firstActiveKey = undefined;
  var panes = [];
  react_1["default"].Children.forEach(props.children, function (child, index) {
    if (!react_1["default"].isValidElement(child)) return;
    var key = child.key;
    if (typeof key !== 'string') return;

    if (index === 0) {
      firstActiveKey = key;
    }

    childrenRecord[key] = child.props.children;
    panes.push(child);
  });

  var _ahooks_1$useControll = ahooks_1.useControllableValue(props, {
    valuePropName: 'activeKey',
    defaultValuePropName: 'defaultActiveKey',
    defaultValue: firstActiveKey,
    trigger: 'onChange'
  }),
      activeKey = _ahooks_1$useControll[0],
      setActiveKey = _ahooks_1$useControll[1];

  return /*#__PURE__*/React.createElement("div", {
    className: classnames_1["default"](classPrefix, props.className),
    style: props.style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-tab-list"
  }, panes.map(function (pane) {
    var _classnames_1$default;

    return /*#__PURE__*/React.createElement("div", {
      key: pane.key,
      className: classPrefix + "-tab-wrapper"
    }, /*#__PURE__*/React.createElement("div", {
      onClick: function onClick() {
        var _pane$key;

        setActiveKey((_pane$key = pane.key) == null ? void 0 : _pane$key.toString());
      },
      className: classnames_1["default"](classPrefix + "-tab", (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-tab-active"] = pane.key === activeKey, _classnames_1$default))
    }, pane.props.title));
  })), panes.map(function (pane) {
    if (pane.props.children === undefined) {
      return null;
    }

    if (pane.key === activeKey) {
      return /*#__PURE__*/React.createElement("div", {
        key: pane.key,
        className: classPrefix + "-content"
      }, pane.props.children);
    }

    if (pane.props.forceRender) {
      return /*#__PURE__*/React.createElement("div", {
        key: pane.key,
        style: {
          display: 'none'
        }
      }, pane.props.children);
    }

    return null;
  }));
};

Tabs.TabPane = TabPane;
exports["default"] = Tabs;