"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});

var react_1 = __importDefault(require("react"));

var with_default_props_1 = require("../../utils/with-default-props");

var classnames_1 = __importDefault(require("classnames"));

var classPrefix = "am-tag";
var colorRecord = {
  "default": '#666666',
  primary: '#1677FF'
};
var defaultProps = {
  color: 'default',
  fill: 'solid',
  round: false
};
var Tags = with_default_props_1.withDefaultProps(defaultProps)(function (props) {
  var _colorRecord$props$co, _classnames_1$default;

  var color = (_colorRecord$props$co = colorRecord[props.color]) != null ? _colorRecord$props$co : props.color;

  var style = _extends({
    '--color': props.fill === 'outline' ? 'transparent' : color,
    color: props.fill === 'outline' ? color : '#ffffff',
    borderColor: color
  }, props.style);

  return /*#__PURE__*/React.createElement("span", {
    style: style,
    className: classnames_1["default"](classPrefix, (_classnames_1$default = {}, _classnames_1$default[classPrefix + "-round"] = props.round, _classnames_1$default), props.className)
  }, props.children);
});
exports["default"] = Tags;